/* -*-c-*-
 *
 * $Id: tx-serial-unix.h,v 1.2 2002/01/30 09:25:15 mdw Exp $
 *
 * Unix/POSIX serial port transport
 *
 * (c) 2001 Mark Wooding
 */

/*----- Licensing notice --------------------------------------------------* 
 *
 * This file is part of Jog: Programming for a jogging machine.
 *
 * Jog is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Jog is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jog; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*----- Revision history --------------------------------------------------* 
 *
 * $Log: tx-serial-unix.h,v $
 * Revision 1.2  2002/01/30 09:25:15  mdw
 * Modify for new transport configuration.  Set PowerJog parameters as the
 * default.
 *
 * Revision 1.1  2002/01/25 19:34:45  mdw
 * Initial revision
 *
 */

#ifndef TX_SERIAL_UNIX_H
#define TX_SERIAL_UNIX_H

#ifdef __cplusplus
  extern "C" {
#endif

/*----- Header files ------------------------------------------------------*/

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#ifndef TXPORT_H
#  include "txport.h"
#endif

/*----- Functions provided ------------------------------------------------*/

/* --- @txsu_shutdown@ --- *
 *
 * Arguments:	---
 *
 * Returns:	---
 *
 * Use:		Restores terminal settings on exit.
 */

extern void txsu_shutdown(void);

extern txport *txsu_create(const char */*file*/);
extern int txsu_configure(txport */*txg*/,
			  const char */*k*/, const char */*v*/);
extern void *txsu_fetch(void */*txv*/);
extern ssize_t txsu_write(txport */*txg*/,
			    const void */*p*/, size_t /*sz*/);
extern void txsu_destroy(txport */*txg*/);

#ifdef TX_LIST
   static const struct txfile txsu_fv[] = {
     { "JOGSERIAL", 0 },
     { 0, "/dev/ttyS0" },
   };

   static txport_ops txsu_ops = {
     TX_LIST, "serial-unix", txsu_fv,
     "flow=none;baud=9600;format=8-odd-1;newline=cr",
     txsu_create, txsu_configure, txsu_fetch, txsu_write, txsu_destroy
   };
#  undef TX_LIST
#  define TX_LIST &txsu_ops
#endif

/*----- That's all, folks -------------------------------------------------*/

#ifdef __cplusplus
  }
#endif

#endif
